## H2O Wave

<img width='50%' src="assets/brand/wave-type-yellow.png" alt="Wave logo">

<p>
  <img alt="PyPI - Downloads" src="https://img.shields.io/pypi/dm/h2o-wave?color=FBE52B">
  <img alt="License" src="https://img.shields.io/github/license/h2oai/wave?color=yellow">
  <img alt="PyPI" src="https://img.shields.io/pypi/v/h2o-wave?label=current-version">
  <img alt="Twitter Follow" src="https://img.shields.io/twitter/follow/h2o_wave">
  <img alt="Contributor covenant" src="https://img.shields.io/badge/Contributor%20Covenant-2.0-4baaaa.svg">
</p>

### Realtime Web Apps and Dashboards for Python and R

**New!** *[R Language API](https://wave.h2o.ai/blog/r-api-preview) Build and control Wave dashboards using R!*

**New!** *Easily integrate AI/ML models into your apps using [Wave ML](https://github.com/h2oai/wave-ml) for automatic machine learning.*

H2O Wave is a software stack for building beautiful, low-latency, realtime, browser-based applications and dashboards entirely in Python/R without using HTML, Javascript, or CSS.

H2O Wave excels at capturing information from multiple sources and broadcasting them live over the web, letting you build and deploy realtime analytics with dramatically less effort.

- [Download](https://github.com/h2oai/wave/releases) / [How to install](https://wave.h2o.ai/docs/installation/)
- [Documentation](https://wave.h2o.ai/): [Getting Started](https://wave.h2o.ai/docs/getting-started/) / [Gallery and Examples](https://wave.h2o.ai/docs/examples/) / [Python API](https://wave.h2o.ai/docs/api/index/)
- [Roadmap 2021](https://github.com/h2oai/wave/issues/693)
- [Developing](https://github.com/h2oai/wave/blob/master/.github/CONTRIBUTING.md#development-setup)
- [Discuss / Support / Q&A / Ideas](https://github.com/h2oai/wave/discussions)
- [Report a problem](https://github.com/h2oai/wave/issues/new/choose)
- [Blog](https://wave.h2o.ai/blog/) / [@h2o_wave](https://twitter.com/h2o_wave)

### Responsive Layouts

![Dashboard](website/blog/assets/2021-01-17/dashboards.png)

![Dashboard](website/blog/assets/2021-01-17/dashboard_red.png)

![Dashboard](website/blog/assets/2021-01-17/dashboard_blue.png)

![Dashboard](website/blog/assets/2021-01-17/dashboard_orange.png)

![Dashboard](website/blog/assets/2021-01-17/dashboard_cyan.png)

![Dashboard](website/blog/assets/2021-01-17/dashboard_mint.png)

![Dashboard](website/blog/assets/2021-01-17/dashboard_purple.png)

Code: https://github.com/h2oai/wave/tree/master/py/demo

### Themes

![Light Theme](assets/visuals/theme-light.png)

![Neon Theme](assets/visuals/theme-neon.png)

(Coming soon!)

![Dark Theme](assets/visuals/theme-dark.png)

### 80+ components, 175+ examples

More at https://wave.h2o.ai/docs/examples

![Components](assets/visuals/components-1.png)

![Visualizations](assets/visuals/components-2.png)

### License

H2O Wave is licensed under the Apache License 2.0. See [LICENSE](LICENSE) for more information.
